#ifndef LZWIncluded
#define LZWIncluded

#include "config.h"

typedef struct{
	unsigned char* code;
	unsigned short codeLen; //in Bytes
} Code;

// LZW-Algorith for GIF-Images
class LZW{

private:

	unsigned char currCodeLen; //current code length in bits
	unsigned short lastCodeTableEntry; //last entry in codeTable
	unsigned char bitdepth;
	Code lastCodedSequence;
	Code codeTable[4096];
	
	unsigned char tempBitsBitCount; //number of saved bits in tempBits
	unsigned int tempBits; //to be added to next input

	bool finished;
	
public:
	LZW(unsigned char bitdepth);
	bool isFinished();
	void reset();
	void decodeByte(unsigned char input, char*& output, unsigned short& outputLen);
	~LZW();

};

#endif
